package com.zfabrik.util.function;

import java.util.function.Function;

/**
 * A function that optionally throws an exception. 
 * 
 * Together with Java's type inference this interface is very useful
 * for many cases, where using {@link Function} would require extra handling of checked exceptions
 */
@FunctionalInterface
public interface ThrowingFunction<T,R, E extends Exception> {

    /**
     * Accept a value
     *
     */
    R accept(T t) throws E;
}
